package proxy.soap;

import java.net.*;
import java.util.*;
import org.w3c.dom.*;
import org.apache.soap.*;
import org.apache.soap.encoding.*;
import org.apache.soap.encoding.soapenc.*;
import org.apache.soap.rpc.*;
import org.apache.soap.util.xml.*;
import org.apache.soap.messaging.*;
import org.apache.soap.transport.http.*;

public class HelloProxy
{
  private Call call;
  private URL url = null;
  private String stringURL = "http://localhost:9080/HelloWorldSample/services/Hello_Port";
  private java.lang.reflect.Method setTcpNoDelayMethod;

  public HelloProxy()
  {
    try
    {
      setTcpNoDelayMethod = SOAPHTTPConnection.class.getMethod("setTcpNoDelay", new Class[]{Boolean.class});
    }
    catch (Exception e)
    {
    }
    call = createCall();
  }

  public synchronized void setEndPoint(URL url)
  {
    this.url = url;
  }

  public synchronized URL getEndPoint() throws MalformedURLException
  {
    return getURL();
  }

  private URL getURL() throws MalformedURLException
  {
    if (url == null && stringURL != null && stringURL.length() > 0)
    {
      url = new URL(stringURL);
    }
    return url;
  }

  public synchronized org.w3c.dom.Element sayHello(org.w3c.dom.Element firstName) throws Exception
  {
    String targetObjectURI = "null";
    String SOAPActionURI = "sayHello";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via HelloProxy.setEndPoint(URL).");
    }

    // create message envelope and body
    Envelope msgEnv = new Envelope();
    Body msgBody = new Body();
    Vector vect = new Vector();

    vect.add(firstName);
    msgBody.setBodyEntries(vect);
    msgEnv.setBody(msgBody);

    // create and send message
    Message msg = new Message();
    msg.send(getURL(),SOAPActionURI, msgEnv);

    // receive response envelope
    Envelope env = msg.receiveEnvelope();
    Body retbody = env.getBody();
    java.util.Vector v = retbody.getBodyEntries();

    return (Element)v.firstElement();
    
  }

  protected Call createCall()
  {
    SOAPHTTPConnection soapHTTPConnection = new SOAPHTTPConnection();
    if ( setTcpNoDelayMethod != null)
    {
      try
      {
        setTcpNoDelayMethod.invoke(soapHTTPConnection, new Object[]{Boolean.TRUE});
      }
      catch (Exception ex)
      {
      }
    }
    Call call = new Call();
    call.setSOAPTransport(soapHTTPConnection);
    SOAPMappingRegistry smr = call.getSOAPMappingRegistry();
    return call;
  }
}
